//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int TM_Period = 7;
extern int TM_Shift  = 2;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 
//
//
//
//
//

double UpH[];
double DnH[]; 
double SpanA_Buffer[];
double SpanB_Buffer[];
double trend[];

//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   
   IndicatorBuffers(5); 
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);  
   SetIndexBuffer(2,SpanA_Buffer); 
   SetIndexBuffer(3,SpanB_Buffer); 
   SetIndexBuffer(4,trend);
   IndicatorShortName(" Icho Trend Histo ");
     
return(0);
}

//
//
//
//
//

int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
       
       double thi    = High[i];
       double tlo    = Low[i];
       double tprice = 0;
       if (i >= Bars - TM_Period) continue;
       for(k = 0; k < TM_Period; k++)
       {
           tprice = High[i+k];
           if(thi < tprice)  thi = tprice;
         
           tprice = Low[i+k];
           if(tlo  > tprice) tlo = tprice;
       }
       
       if ((thi+tlo) > 0.0) 
            SpanA_Buffer[i] = (thi + tlo)/2; 
       else SpanA_Buffer[i] = 0;
            SpanB_Buffer[i] = SpanA_Buffer[i+TM_Shift];
       
       //
       //
       //
       //
       //
       
       UpH[i]   = EMPTY_VALUE;
       DnH[i]   = EMPTY_VALUE; 
       trend[i] = trend[i+1];
         if (SpanA_Buffer[i]>SpanB_Buffer[i]) trend[i] = 1;
         if (SpanA_Buffer[i]<SpanB_Buffer[i]) trend[i] =-1;
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;    
   }
   if (alertsOn)
   {
   if (alertsOnCurrent)
   int whichbar = 0;
   else whichbar = 1;
   
   if (UpH[whichbar]!= EMPTY_VALUE && UpH[whichbar+1]==EMPTY_VALUE) doAlert("BUY");
   if (DnH[whichbar]!= EMPTY_VALUE && DnH[whichbar+1]==EMPTY_VALUE) doAlert("SELL");
   }
return(0);
}
  
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," icho ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " icho  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}  